#! /usr/bin/env python
# -*- coding: utf-8 -*-
"""
Kysrun application launcher (http://colabti.org/kysrun).
Copyright (C) 2008  Francois Beerten

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
"""

import time
from Tkinter import *
import proposers

proposers.setupOnFirstStart()

root = Tk()

w = Label(root, text="TK Kysrun")
w.pack()
querystring = StringVar()
query = Entry(root, textvariable = querystring)
query.pack()
p = Listbox(root)
p.pack()
author = Label(root, text="(c) 2008 Francois Beerten")
author.pack()

current = []
def propose():
   global current

   s = query.get()
   p.delete(0, END)
   current = proposers.findPropositions(s)
   for i in current:
       p.insert(END, i.display())
   if len(current):
      p.select_set(0)

def querycallback(a, b, mode):
   propose()
querystring.trace('w', querycallback)

def close(event = None):
   quit()
root.bind_all("<Escape>", close)

def start(event):
   if len(current):
      position = int(p.curselection()[0])
      current[position].start()
      p.pack_forget()
      query.pack_forget()
      author.pack_forget()
      m = Label(root, text="Starting " + current[position].display())
      m.pack()
      author.pack()
      root.after(1000, close)
   else:
      close()
root.bind_all("<Return>", start)

def moveSelection(diff):
   size = len(current)
   if size:
      i = int(p.curselection()[0])
      p.select_clear(0, END)
      i += diff
      i = divmod(i, size)[1]
      p.select_set(i)

def goUp(event):
   moveSelection(-1)
def goDown(event):
   moveSelection(1)
root.bind_all("<Up>", goUp)
root.bind_all("<Down>", goDown)

query.focus()

root.mainloop()

